Attribute VB_Name = "Global"
Option Explicit

Global Machine As Integer   'The attached machine
Public Const NOMACHINE = 0
Public Const SIPROMACHINE = 1
Public Const TESTMACHINE = 2

Public Programing As Boolean

''' Some GLOBAL VARIABLES to control execution '
Global AbortExec As Boolean
Global Stepping As Integer
Global Simulate As Boolean
Global Pause As Boolean
Global Suspended As Boolean
Global InMacro As Integer
Global FootSwitchState As Boolean
Global FCButtonState As Boolean     'The physical button
Global VButtonState As Boolean     'The Virtual (on screen) button
Public ProgCopy As String      ' Copy for redo
Public SilentRun As Boolean
Public SuspendLine As Integer
Public SuspendStep As Integer
Public RunList As String
Public Running As String
Public BreakLine As Integer
Public Const BYSTEP = 1     'Constants for run mode
Public Const SIMUL = 2
Public Const TOSTOP = 4

Public TheCaption As String

Public LineNo As Integer    'To show current program line
Public StepNo As Integer    'To  show current program step
Public LastPosDone As String

Public PrgFile As String    'Path to files
Public CcxFile As String
Public GgxFile As String
Public PrjFile As String

''' For X (carriage ) axis
Public Type DChamber    'Pos and size for a chamber
    Org As Single
    Width As Single
    Free As Single
End Type
Public Chambers(1 To 4) As DChamber
Public Chamber As Integer  'Current chamber( or former)
'Dim ChamberFree As Single 'Space remaining in the current chamber
'' Moved in DChamber
Public RefOffset As Single 'Actual reference offset from ZERO
Public PosT As Single  'Actual carriage location relative to reference (in mm)'' Why not a long ?
Public Direction As Integer '(1 = to right, -1 = to left)
Const TORIGHT = 1
Const TOLEFT = -1

''' For Y (shaft) axis
Dim PosR As Single '' Why not a long ?
Public ShaftFree As Boolean

''' For V (carriage lift) axis
Global Const GUIDETRAVEL = 200
Public Guide As Integer    ' Current guide
Public Guides(1 To 4) As Single 'Offset for guides
Public GuideTarget As Single    ' Where it should be
Public GuideCurrent As Single   ' Where it really is
Public GuideFromPark As Single  ' Where it was before parking
Global Const GUIDESTEPPERMM = 10       ' Steps per mm
Global Const VGUIDEPERIOD = 100 ' Times Service.Timer1 interval
Public TbVstep(0 To 7) As Byte   'Steps for the motors (10, 8, 9, 1, 5, 4, 6, 2)
Public CurVstep As Integer
Public GDone As Boolean


Dim Turns As Single    'Last know values. Used by default if not specified
Dim Pitch As Single
Dim Layers As Single

Global RealVeloR As Long
Global RealVeloT As Long
Global RealAccelR As Long
Global RealAccelT As Long

Public Sub Main()
Dim S As String

    Machine = 0
    S = LCase(Command$)
    If Len(S) Then
    
    Else
        StartForm.Show
    End If
    Select Case Machine
        Case NOMACHINE
            Form1.Show
        Case SIPROMACHINE
            Service.Show
        Case TESTMACHINE
            Exit Sub
    End Select
End Sub

Public Sub InitSpVars() 'Initialize the four special variables
Dim I As Integer
'' TODO '' Add Guides ?
    
    SetNVar ":LargeurC1", Chambers(1).Width
    SetNVar ":LargeurC2", Chambers(2).Width
    SetNVar ":LargeurC3", Chambers(3).Width
    SetNVar ":LargeurC4", Chambers(4).Width
    Form1.RefreshNVars
End Sub

Public Sub ProgExec(S As String)
Dim LLen As Integer
Dim I As Integer
Dim Sleft As String
Dim Command As String

    Form1.BtDummy.SetFocus    'Immune default button
    While Suspended     'Panic ! Stay here
        Wait 100
    Wend
    If AbortExec Then
        ShowFatal "--- Excution abandonne ---"
        S = ""
        Exit Sub
    End If
    If Len(S) = 0 Then
        If InMacro Then
            ShowInfo "--- Fin de macro ---"
        Else
            ShowInfo "--- Fin du programme ---"
        End If
        Exit Sub
    End If
'    Debug.Print S
    LLen = InStr(S, vbCrLf) 'Look for a Line feed (eol)
'    Beep
    SuspendLine = LineNo
    LineNo = LineNo + 1
'    If SilentRun Then
'        If LineNo = SuspendLine And StepNo = SuspendStep Then 'Target reached
'            SilentRun = False
'            ShowInfo "Point de reprise . . ."
'        End If
'    End If
    If LLen > 1 Then
        SuspendStep = StepNo
        StepNo = StepNo + 1
        ShowLineStep
        Sleft = Trim(Left(S, LLen))               'Current line)
        #If Nohard Then
            Debug.Print "Current Line: "; TTrim(Sleft)
        #End If
        Form1.CurLine.Caption = Sleft
        S = Right(S, Len(S) - LLen)            'Remainder
        I = InStr(Sleft, "#")               'Look for comment
        If I Then Sleft = Left(Sleft, I - 1) 'Remove comment from current line
        If Len(Sleft) Then 'Something else ?
'            Form1.BtDoProg.Enabled = False
            Command = GetCommand(Sleft)
            Sleft = TTrim(Sleft)
'            Select Case UCase(Left(Trim(Command), 1)) 'Commands are not case sensitive
            Select Case Left(Trim(Command), 1) 'Commands ARE case sensitive
                Case "A"    'Acceleration
                    Kaccel = 1 + 10000 \ EvalExp(GetParam(Sleft))   'Can't be zero.
                    SetNVar ":Accel", Kaccel
                    ShowInfo "Acclration: " & Format(Kaccel)
                Case "C"   'Load former file
                    LoadFormer Sleft
                Case "G"    'Load guide file infos
                    LoadGuide Sleft
                Case "R" ' Set reference
                    SetRefV Sleft
                Case "P"   ' "POSITION"
                    Position Sleft  ' Add (sub) guide offset
                Case "B"   ' "BOBINE", "BOBINER"
                    Roll Sleft  ', 0
                Case "V"    'Rotation speed in rpm
                    SetRpm Sleft
                Case "H", "^"
                    ShowInfo "Positionne l'ascenseur"
                    PosVGuide Sleft
'                Case "Z"
'                    ShowInfo "Recherche du zro, patientez !"
'                    GoToZero
                Case "[", "D", "T"
                    BlocBegin Sleft, S   'Will not return before end of bloc
                Case "]", "F"   'End of bloc, exit
                    Exit Sub
                Case "S"    '"IF" command. . .
                    IfBegin Sleft, S
                Case "!", "I"
                    If Len(Sleft) Then
                        ShowInfo Left(Sleft, Len(Sleft))
                    Else
                        ShowInfo "Presser bouton"
                    End If
                    WaitFCbutton
                Case "(", "{", "M"  'Insert/execute another program (macro)
                    DoMacro Sleft, S
                Case "E", "", "X"
                    StopOrSetMode Sleft
                Case Else   'Not a command, may be a variable affectation with or without spaces
                    Sleft = Command & Sleft
                    If Len(Sleft) <> 0 Then  'Empty line, ignore
                        I = InStr(Sleft, "=")
                        If I <> 0 Then  'OK, it is an affectation
                            If IsVar(Left(Sleft, I - 1)) Then
                                AffectVar Sleft
                            Else
                                ShowFatal "Mauvais nom de variable"
                            End If
                        Else
                            ShowFatal "Commande inconnue"
                        End If
                    End If
                End Select
        End If
    Else
        S = Right(S, Len(S) - LLen) 'Eat the line
        If Len(S) < 2 Then S = ""   'Too short !
    End If
    If Len(Trim(S)) Then ProgExec S  'Up to end of string
End Sub
Private Sub StopOrSetMode(S As String)
Dim Mode As Single

    Mode = EvalExp(S)
'' Set chkboxes according to mode
    Form1.SetCkMode Mode
    If SilentRun Then
        ShowInfo "STOP ATTEIND"
    End If
End Sub

Private Sub WaitStep()
'Returns immediatly if not stepping, else wait . . .
    
    If AbortExec Then Exit Sub
    If SilentRun Then Exit Sub
    If Stepping Then
        Pause = True
        While Pause And Not AbortExec
            Wait 100
        Wend
    End If
End Sub

Private Sub WaitFCbutton()

    If AbortExec Then Exit Sub
    If SilentRun Then Exit Sub
    Form1.BtFcbutton.Enabled = True 'Enable Virtual button
    SetEndCycleOn   'Light ON physical button
    Form1.BtDoProg.Enabled = False
    VButtonState = False
    While (Not (FCButtonState Or VButtonState)) And (Not AbortExec)    'Until someone else set it true
        Wait 100
        If IOSwitchesB And FOOTSWITCH Then      'Op is now allowed to press footswitch to free shaft
            If Not ShaftFree Then
                ShaftFree = True
                DisableDriverR
            End If
        Else
            If ShaftFree Then
                ShaftFree = False
                HReset RAxis
                MoveR 0, RELATIVE
                EnableDriverR
            End If
        End If
    Wend
    If ShaftFree Then   'Insure shaft is not free
        ShaftFree = False
        HReset RAxis
        MoveR 0, RELATIVE
        EnableDriverR
    End If
    SetEndCycleOff  'Light OFF physical button
    While FCButtonState ' Wait for OP releases the button
        Wait 100
    Wend
'    FCButtonState = False
    Form1.BtFcbutton.Enabled = False
'    SetEndCycleOff  'Light OFF physical button
    Form1.BtDoProg.Enabled = True
End Sub

Public Sub ShowInfo(S As String)
    
    If SilentRun Then Exit Sub
    Form1.TxInfo.Text = ExpandExp(S)
    WaitStep
End Sub

Public Function ExpandExp(S As String) As String
'Expand expressions included in curly brackets
Dim I As Integer
Dim T As String
Dim L As Integer
Dim E As String
    
    I = InStr(S, "{")   'Look for an open curly brace
    If I Then
        E = Left(S, I - 1)  'Get the left part
        T = Mid(S, I + 1)
        L = InStr(T, "}") - 1  'and a balanced closing one
        If L Then
            E = E & EvalExp(Left(T, L)) & Right(T, Len(T) - L - 1)
            ExpandExp = ExpandExp(E)    'More expressions to extend ?
            Exit Function
        End If
    Else
        ExpandExp = S
    End If
End Function

Public Sub ShowFatal(S As String)
    
    Beep
    Form1.TxInfo.Text = Str(LineNo) & " in " & Running & " Erreur: " & S
'   AbortExec = True
'    Pause = True    'Force pause
'    While Pause And Not AbortExec
'        Wait 100
'    Wend
    AbortExec = True
End Sub

Private Sub IfBegin(Sleft As String, S As String)
Dim Condition As Single

    Condition = EvalExp(Sleft)
    ShowInfo "Dbut bloc  excuter si <" & Sleft & "> diffrent de zro"
    If Condition > 0 Then
        ProgExec S
    Else
        EatBloc S   'skip
        ShowLineStep
    End If
    ShowInfo "Fin SI"
End Sub

Private Sub BlocBegin(Sleft As String, S As String)
Dim Cline As Integer    'Line number at call
Dim LastLine As Integer 'Line number at end of loop
Dim CE As String
'Dim Count As Integer
Dim Bloc As String
Dim TFool As Single
        
    Cline = LineNo  'Get the current line number
'   CE = GetEndOfLine(S)
'    CE = GetCommand(s)
    CE = Sleft
    TFool = EvalExp(CE)
    Bloc = S    'To be repeated
    ShowInfo "Dbut bloc  excuter tant que <" & CE & "> diffrent de zro"
    If AbortExec Then Exit Sub
    While EvalExp(CE) > 0
        If AbortExec Then Exit Sub
        ProgExec Bloc       ' Will return at end of THIS bloc
        Bloc = S            ' ready for repeat
        If EvalExp(CE) >= TFool Then
            ShowFatal "< " & CE & "> n'volue pas correctement"
        End If
        LastLine = LineNo
        LineNo = Cline
        StepNo = StepNo - 1  ' ??
    Wend
    EatBloc S
'    LineNo = LastLine
    StepNo = StepNo + 1  ' ?? again ??
    ShowLineStep
    ShowInfo "Fin TANT QUE"
End Sub

Private Sub EatBloc(S As String)
Dim Command As String
Dim L As String
Dim I As Integer

    While Len(S)
        L = GetEndOfLine(S)
        If Len(L) Then
            LineNo = LineNo + 1
            Command = GetCommand(L)
            Select Case Left(Trim(Command), 1)
                Case "[", "D", "T", "S"
                    I = I + 1
                Case "]", "F"
                    I = I - 1
            End Select
        End If
        If I < 0 Then
            LineNo = LineNo - 1 ' Ooops !
            Exit Sub
        End If
    Wend
End Sub

Private Sub Roll(S As String)
Dim X As Single
Dim T As String
Dim P As String
Dim L As String
Dim W As Single
Dim TLeft As Single
Dim TC As Single
Dim Diff As Single
Dim CTurns As Single
Dim N As Integer
Dim Reverse As Integer

#If Nohard Then
    Debug.Print "Roll "; S
#End If
    T = GetParam(S)     '1st is turns
    P = GetParam(S)     '2nd is pitch
    L = GetParam(S)     '3rd is layers
    If T = "?" Then      'Get the two other parameters and compute missing
        If P <> "_" Then Pitch = EvalExp(P)
        If L <> "_" Then Layers = EvalExp(L)
        Turns = Layers * Chambers(Chamber).Free / Pitch    ' Turns that will fits
'        If Turns < 1 Then Turns = Layers * Chambers(Chamber).Width / Pitch  'Less than one: next layer
    ElseIf P = "?" Then
        If T <> "_" Then Turns = EvalExp(T)
        If L <> "_" Then Layers = EvalExp(L)
        Pitch = Layers * Chambers(Chamber).Free / Turns     ' Pitch to use to fill a layer
    ElseIf L = "?" Then
        If P <> "_" Then Pitch = EvalExp(P)
        If T <> "_" Then Turns = EvalExp(T)
        Layers = Pitch * Turns / Chambers(Chamber).Width
    End If              ' All parameters are know
    ShowInfo Str(Turns) & " tour(s) au pas de" & Str(Pitch) & "mm en" & Str(Layers) & " couche(s)"
    If AbortExec Then Exit Sub  'Don't do more
    SetNVar ":Tours", Turns
    SetNVar ":Pas", Pitch
    SetNVar ":Couches", Layers
    Form1.RefreshNVars
    SetRef.LbTurns.Caption = "0.0"
    If Not Simulate Then LM628Poke1 RAxis, DFH   'Voids accumulation in positions register
'    CTurns = 0
    If Pitch = 0 Or Turns = 0 Or Layers = 0 Then   'No travel, just rotate shaft
        If Not Simulate Then
            Form1.BtDoProg.Enabled = False
            MoveR Turns, RELATIVE
            Form1.BtDoProg.Enabled = True
        End If
        CTurns = Turns
'        ShowTurns CTurns
        Exit Sub
    End If
'' TODO : Since total turns and total layers are know, count layers remaining rather than turns.
'' While Layers . . .
''
    
    TLeft = Turns   'Local turns counter
    While TLeft <> 0
        If AbortExec Then
            Form1.BtDoProg.Enabled = True
            Exit Sub
        End If
        Reverse = 1
        If Pitch < 0 Then
            Reverse = -1
            Pitch = Abs(Pitch)
        End If
        If Chambers(Chamber).Free <= Abs(Pitch) Then    'No enough room
            Chambers(Chamber).Free = Chambers(Chamber).Width    'A new layer
            Direction = -Direction
        End If
        TC = Chambers(Chamber).Free / Pitch  'How many turns could fits in this layer
        
        If TLeft < TC Then TC = TLeft    'But no more than specified !
        DisableOp   'Voids operator intervention while motors move
        Form1.BtDoProg.Enabled = False
        If Not Simulate Then
            W = TC * Pitch 'Width to use
            If W > Chambers(Chamber).Free Then W = Chambers(Chamber).Free
            MoveSync Reverse * Direction * W, TC
        Else
            W = TC * Pitch 'Width to use
            If W > Chambers(Chamber).Free Then W = Chambers(Chamber).Free
            SetRef.CarLoc = SetRef.CarLoc + Reverse * Direction * W
            SetRef.WaitMe
            SetRef.LbTurns.Caption = Format(TC, "#.0")
        End If
        EnableOp
        Chambers(Chamber).Free = Chambers(Chamber).Free - TC * Pitch * Reverse
        If Chambers(Chamber).Free <= Pitch Then    'No enough room
            Chambers(Chamber).Free = Chambers(Chamber).Width    'A new layer
            Direction = -Direction
        End If
        TLeft = TLeft - TC
    Wend
'    SetNVar ":CCN", CSng(Chamber)  'now in position
    SetNVar ":DChambre", Chambers(Chamber).Width - Chambers(Chamber).Free
    SetNVar ":SBobinage", CSng(Direction)
    Form1.RefreshNVars
    Form1.BtDoProg.Enabled = True
'    ShowTurns CTurns
End Sub

Private Function WidePitch(Pitch As Single, Turns As Single, CWidth As Single) As Single
' Increase pitch so that Turns fit in an integral number of layers having a width of CWidth
Dim L As Single 'Layers needed

    WidePitch = Pitch   'May be we are lucky !
    L = Turns * Pitch / CWidth  'How many layers needed ?
    If L - Int(L) <> 0 Then     'Not an integer
        L = Int(L) + 1           'Add one layer
        WidePitch = L * CWidth / Turns 'Total available space divided by turns.
    End If
End Function
Public Function Reposition() As Boolean
    
    If Len(LastPosDone) Then
        Position LastPosDone
        LastPosDone = ""
        Reposition = True
    End If
End Function

Private Sub Position(S As String)
' Up to 4 params: guide, chamber, origin (side)and offset separated by any no print char
' W/O parameters: Park up and Right
Dim X As Single
Dim V As Single
Dim P As String
Dim Offset As Single
Dim O As String
Dim HG As Single    '

    LastPosDone = S
    ParkVguides
    If Len(S) <= 1 Then  'Only one or no parameter at all: park
'' TODO '' Check Simulation
        Select Case UCase(S)
         Case "D"
            ShowInfo "Dgagement  droite"
            If AbortExec Then Exit Sub
            Form1.BtDoProg.Enabled = False
            If Not Simulate Then
                MoveTAbs TOTALTRAVEL
            Else
                SetRef.CarLoc = TOTALTRAVEL
                SetRef.WaitMe
            End If
         Case "G"
            ShowInfo "Dgagement  gauche"
            If AbortExec Then Exit Sub
            Form1.BtDoProg.Enabled = False
            If Not Simulate Then
                MoveTAbs 0
            Else
                SetRef.CarLoc = 0
                SetRef.WaitMe
            End If
         Case "H"
            ShowInfo "Dgagement en haut"
            If AbortExec Then Exit Sub
         Case Else
            ShowInfo "Parking"
            If AbortExec Then Exit Sub
            Form1.BtDoProg.Enabled = False
            If Not Simulate Then
                MoveTAbs TOTALTRAVEL
            Else
                SetRef.CarLoc = TOTALTRAVEL
                SetRef.WaitMe
            End If
        End Select
        Form1.BtDoProg.Enabled = True
        Exit Sub
    End If
    Chamber = 1     'Default values if not specified.
    Guide = 1
    X = EvalExp(GetParam(S))
    If X > 0 And X < 5 Then Guide = Int(X)
    HG = EvalExp(GetParam(S))
    SetNVar ":HGuide", HG
    X = EvalExp(GetParam(S))
    If X > 0 And X < 5 Then Chamber = Int(X)
    SetNVar ":NChambre", CSng(Chamber)
    V = Chambers(Chamber).Org - Guides(Guide)   'Add Guide offset wich is negative !
    P = GetParam(S)
    Offset = EvalExp(GetParam(S))
    Chambers(Chamber).Free = Chambers(Chamber).Width - Offset
    SetNVar ":NDispo", Chambers(Chamber).Free
    Select Case P   'May be litteral "G" or "D"
        Case "D"
            Direction = TOLEFT
            V = V + Chambers(X).Width - Offset
            P = " droite"
            O = " -" & Format(Offset) & "mm"
        Case "G"
            Direction = TORIGHT
            V = V + Offset  'EvalExp(GetParam(S))
            P = " gauche"
            O = " +" & Format(Offset) & "mm"
        Case Else
            If EvalExp(P) >= 0 Then 'Any positive value means relative to LEFT
                Direction = TORIGHT
                V = V + Offset
                P = " gauche"
                O = " +" & Format(Offset) & "mm"
            Else
                Direction = TOLEFT
                V = V + Chambers(X).Width - Offset
                P = " droite"
                O = " -" & Format(Offset) & "mm"
            End If
    End Select
    ShowInfo "Positionnement guide" & Str(Guide) & " " & P & " de chambre" & Str(Chamber) & O & " (" & Format(V + RefOffset) & "mm)"
    If AbortExec Then Exit Sub
    Form1.BtDoProg.Enabled = False
    If Not Simulate Then
'''' Use absolute positionning to move carriage alone
        MoveTRef V  'MoveTRef absolute relative to RefOffset
    Else
        SetRef.CarLoc = V + RefOffset
        SetRef.WaitMe
    End If
    SetNVar ":NGuide", CSng(Guide)
    Form1.RefreshNVars
    Form1.BtDoProg.Enabled = True
End Sub
Private Sub SetRpm(S As String)
Dim X As Single

    X = EvalExp(GetParam(S))
    ShowInfo "Vitesse broche " & X & " tours minute"
    Form1.HsRotate.Value = Int(X)
    SetNVar ":Vitesse", X
End Sub

Private Function GetCommand(S As String)
' Remove the command string from S and returns it
Dim I As Integer
Dim L As Integer

    I = 1
    While IsWhite(Mid(S, I, 1)) And I <= Len(S)  'Skip leading white spaces
        I = I + 1
    Wend
    L = I
    While Not IsWhite(Mid(S, L, 1)) And L <= Len(S) 'to next space
        L = L + 1
    Wend
    GetCommand = Mid(S, I, L - I)
    If Len(GetCommand) = 0 Then
        S = ""
        Exit Function
    End If
    ' Returns remaining of the line (if any)
    If Len(S) > Len(GetCommand) Then
        S = Right(S, Len(S) - L)
    Else
        S = ""
    End If
End Function

Private Function GetEndOfLine(S As String)
Dim I As Integer

    I = InStr(S, Chr(10))
    If 1 = 0 Then Exit Function
    GetEndOfLine = Left(S, I)
    S = Mid(S, I + 1)   ', Len(S) - 1)
End Function
Public Function NotWhite(S) As String
' Returns the first notwhite string found in S
Dim I As Integer
Dim L As Integer

    I = 1
    While IsWhite(Mid(S, I, 1)) And I <= Len(S)  'Skip leading white spaces
        I = I + 1
    Wend
    L = I
    While Not IsWhite(Mid(S, L, 1)) And L <= Len(S) 'to next space
        L = L + 1
    Wend
    NotWhite = Mid(S, I, L - I)
End Function

Private Function GetParam(S As String) As String
'Extract /remove and returns param in param from S.
'S truncated.
Dim I As Integer
    
    I = 1
    While IsWhite(Mid(S, I, 1)) And I <= Len(S)  'Skip leading white spaces
        I = I + 1
    Wend
    While Not IsWhite(Mid(S, I, 1)) And I <= Len(S)
        GetParam = GetParam & Mid(S, I, 1)
        I = I + 1
    Wend
    If Len(S) >= I - 1 Then S = Right(S, Len(S) - (I - 1))
End Function

Private Function IsWhite(S As String) As Boolean

    If S = " " Or S = Chr(9) Or S = Chr(10) Or S = Chr(13) Then IsWhite = True
    'space, tab, lf or cr
End Function

Private Sub AffectVar(S As String)
'Affect a value to a variable and return value
Dim I As Integer
Dim Var As String
Dim Value As String
Dim V As Single

    I = InStr(S, "=")
    If I > 0 Then
        Var = TTrim(Left(S, I - 1))
        Value = TTrim(Right(S, Len(S) - I))
        SetNVar Var, EvalExp(Value)
        Form1.RefreshNVars
        ShowInfo "La variable '" & Var & "' vaut " & Str(GetNVar(Var))
    End If
End Sub

Public Function IsVar(S As String) As Boolean
Dim C As Integer
Dim I As Integer

    IsVar = False
    If Len(S) = 0 Then Exit Function
    C = Asc(Left(S, 1)) 'Check for first letter to be lower case or an underscore or an ":"
    If C >= Asc("a") And C <= Asc("z") Or C = Asc(":") Or C = Asc("_") Then 'Good candidate
        For I = 1 To Len(S)     'Let's check remaining
            C = Asc(Mid(S, I, 1))
            If C < Asc("0") Then Exit Function
            If C > Asc("z") Then Exit Function
            If (C > Asc("Z") And C < Asc("_")) Then Exit Function
            If (C > Asc(":") And C < Asc("A")) Then Exit Function
            If C = Asc("'") Then Exit Function
        Next
        IsVar = True    'No forbiden character found
    End If
End Function

Public Function EvalExp(Exp As String) As Single
' Recursive expression parser
' Credits to Jos de Jong

Dim P As Integer
Dim E As String
Dim I As Integer
Dim J As Integer
Dim SRight As String
Dim Sleft As String
Dim Op As String
Dim Temp As Single
    
    E = TTrimAll(Exp) 'Remove all spaces. Better to do that before initial call ! ! !
    Debug.Print "EvalExp "; E
    If IsVar(E) Then
        EvalExp = GetNVar(E)   'just get variable value as string
        Exit Function
    End If
    For J = 1 To 11
        Op = Mid("?<>-+\%/*^E", J, 1)
        P = InP(UCase(E), Op, 255)
        While P > 0
            If IsOp(E, Op, P) Then
                Sleft = Left(E, P - 1)
                SRight = Right(E, Len(E) - P)
                Select Case Op
                Case "?"    'Force any non nul value to be 1
                    Temp = EvalExp(SRight)
                    If Temp <> 0 Then Temp = 1
                    EvalExp = Temp
                    Exit Function
                Case "<"    'Floor
                    EvalExp = Int(EvalExp(SRight))
                    Exit Function
                Case ">"    'Ceil
                    Temp = Int(EvalExp(SRight))
                    If Temp < EvalExp(SRight) Then
                         EvalExp = Temp + 1
                    Else
                         EvalExp = Temp
                     End If
                     Exit Function
                Case "-"
                    EvalExp = EvalExp(Sleft) - EvalExp(SRight)
                    Exit Function
                Case "+"
                    EvalExp = EvalExp(Sleft) + EvalExp(SRight)
                    Exit Function
                Case "*"
                    EvalExp = EvalExp(Sleft) * EvalExp(SRight)
                    Exit Function
                Case "/"
                    If EvalExp(SRight) = 0 Then
'                            ShowInfo "FATAL: " & Str(Sleft) & " / " & Str(SRight) & ": Division par 0"
                        Exit Function
                    End If
                    EvalExp = EvalExp(Sleft) / EvalExp(SRight)
                    Exit Function
                Case "\"    'Integer division
                    If EvalExp(SRight) = 0 Then 'Divide by 0
                        Exit Function
                    End If
                    EvalExp = EvalExp(Sleft) \ EvalExp(SRight)
                    Exit Function
                Case "%"    'Division remainder
                    If EvalExp(SRight) = 0 Then 'Divide by 0
                        Exit Function
                    End If
                    EvalExp = Int(EvalExp(Sleft) Mod EvalExp(SRight))
                    Exit Function
                Case "^"
                    EvalExp = EvalExp(Sleft) ^ EvalExp(SRight)
                    Exit Function
                Case "E"
                    EvalExp = EvalExp(Sleft) * 10 ^ EvalExp(SRight)
                    Exit Function
            End Select
        End If
        If P > 0 Then P = InP(E, Op, P - 1) 'not an operator, search for another before
        Wend
    Next
'Check if expression starts and ends with parenthesis
    If Left(E, 1) = "(" And Right(E, 1) = ")" Then
        E = Mid(E, 2, Len(E) - 2)   'Remove them
        EvalExp = EvalExp(E)        'And evaluate
        Exit Function
    End If
' No more operator, evaluates and returns the operand
    EvalExp = Val(E)
    Exit Function
End Function

Private Function InP(Source As String, Search As String, start As Integer) As Integer
' Search backward for "Search" in "String" returning where it was found.
Dim N As Integer
Dim Bopen As Integer
Dim Bclose As Integer
Dim Sign As String

    N = start
    If N > Len(Source) Then N = Len(Source) - Len(Search) + 1
    Bopen = 0
    Bclose = 0
'    Do
    While N
        Sign = Mid(Source, N, Len(Search))
        If (Sign = Search) And (Bopen = Bclose) Then
            InP = N
            Exit Function
        End If
        If Left(Sign, 1) = "(" Then Bopen = Bopen + 1
        If Left(Sign, 1) = ")" Then Bopen = Bopen - 1
        N = N - 1
    Wend
'    Loop Until N <= 0
    InP = 0
End Function

Private Function IsOp(expr As String, Op As String, N As Integer) As Boolean
Dim Sign As String

    Select Case Op
        Case "+"
            If N = 1 Then
                IsOp = False
                Exit Function
            End If
            If Mid(expr, N - 1, 1) = "E" Then   'Do not accept lower case e wich can be a variable
                If N > 2 Then
                    If InStr("1234567890.", Mid(expr, N - 2, 1)) > 0 Then
                        IsOp = False
                        Exit Function
                    End If
                End If
            End If
            IsOp = True
            Exit Function
        Case "-"
            If N = 1 Then
                IsOp = False
                Exit Function
            Else
                Sign = Left(expr, N - 1)
                Sign = Right(RTrim(Sign), 1)
                If InStr("=?<>+-/*\%^", Sign) > 0 Then
                    IsOp = False
                    Exit Function
                End If
                If Mid(expr, N - 1, 1) = "E" And N > 2 Then
                    If InStr("1234567890.", Mid(expr, N - 2, 1)) > 0 Then
                        IsOp = False
                        Exit Function
                    End If
                End If
            End If
            IsOp = True
            Exit Function
    End Select
    IsOp = True
End Function

Public Sub ShowLineStep()
    
    Form1.LbShowLS.Caption = "Line: " & Str(LineNo) & "   Pas: " & Str(StepNo)
    Form1.SelectLine LineNo
End Sub

Private Sub DisableOp()
'' TODO '' Disable pertinent buttons
'    Form1.MousePointer = vbHourglass
End Sub
Private Sub EnableOp()

'    Form1.MousePointer = vbDefault
End Sub

Private Sub SetRefV(S As String)

    RefOffset = EvalExp(GetParam(S))
    ShowInfo "La rfrence est " & Format(RefOffset, "0.0##")
End Sub

Public Sub ParkVGuide(Guide As Integer)

    Lift.MoveGuide Guide, 0
    While Not GDone
        Wait 100
    Wend
End Sub

Public Sub ParkVguides()

    Lift.MoveGuide 0, 0
    Lift.MoveGuide 1, 0
    While Not GDone
        Wait 100
    Wend
End Sub

Public Sub UnparkVGuide()

    GuideTarget = GuideFromPark
End Sub
Public Sub PosVGuide(S As String)
Dim G As Single
Dim H As Single

    G = EvalExp(GetParam(S))
    H = EvalExp(GetParam(S))
    If G < 0 Or G > 1 Then
        ShowFatal "Pas cet ascenseur !"
        Exit Sub
    End If
    If H < 0 Or H > GUIDETRAVEL Then
        ShowFatal "Pas cet tage"
        Exit Sub
    End If
    Lift.MoveGuide Int(G), Int(H)
    While Not GDone
        Wait 100
    Wend
End Sub

Public Sub WaitForPark()

    While GuideTarget <> GuideCurrent   'Camp here
        Wait 100
    Wend
End Sub

Public Sub DisableDriverV()

    'poke 0 . . .
End Sub

Public Sub EnableDriverV()

    'Poke TbVstep(CurVstep)
End Sub

Public Sub MoveVUp()

    CurVstep = CurVstep + 1
    If CurVstep > 4 Then CurVstep = 0
    EnableDriverV
End Sub

Public Sub MoveVDown()

    CurVstep = CurVstep - 1
    If CurVstep < 1 Then CurVstep = 4
    EnableDriverV
End Sub

Private Sub DoMacro(Sleft As String, S As String)
Dim SaveLineno As Integer
Dim SaveTxProg
Dim SaveS As String
Dim File As String
Dim F As Integer
Dim T As String
Dim Macro As String
Dim Path As String

    If Not MarkRunning(Sleft) Then
        ShowFatal Sleft & " ne peut s'appeler lui mme"
        Exit Sub
    End If
    SaveLineno = LineNo             ' Save caller's context
    SaveTxProg = Form1.TxProg.Text
    SaveS = S
    Path = GetIniString(INIFILE, "PATH", "PROGRAM")
    If Len(Path) = 0 Then Path = App.Path
    File = Path & "\" & NotWhite(Sleft) & ".prg"
    F = IsOpen(File, "R", 10)
    If F = 0 Then
        ShowFatal "--- " & GetFname(File) & " introuvable ---"
        Exit Sub
    End If
    Running = GetFname(File)
    ShowInfo "Excution de " & GetFname(File)
    If AbortExec Then Exit Sub '' TODO Restore current before ?
    While Not EOF(F)
        Line Input #F, T
        Macro = Macro & T & vbCrLf
    Wend
    XClose F, 10
    InMacro = InMacro + 1
    Form1.TxProg.Text = Macro   'This trigs TxProg change etc ....
    Form1.Caption = TheCaption & "( Excution macro:  " & Running & ")"
    LineNo = 0
    ProgExec Macro  ' Execute content of the "macro" file
    LineNo = SaveLineno 'At return, restore context
    Form1.TxProg.Text = SaveTxProg
    Form1.Caption = TheCaption & "(" & GetFname(PrgFile) & ")"
    S = SaveS
    InMacro = InMacro - 1
    FreeRunning Sleft
End Sub

Private Sub LoadFormer(Sleft As String)
Dim F As Integer
Dim I As Integer
Dim File As String
Dim T As String
Dim Path As String

    Path = GetIniString(INIFILE, "PATH", "FORMER")
    If Len(Path) = 0 Then Path = App.Path
    File = Path & "\" & TTrim(Sleft) & ".ccx"
    ShowInfo "Chargement des infos carcasse " & GetFname(File)
    F = IsOpen(File, "R", 10)
    If F = 0 Then
        ShowFatal "--- " & GetFname(File) & " introuvable ---"
        Exit Sub
    End If
    For I = 0 To 7
        Line Input #F, T
        Form1.TxC(I) = T
    Next
    XClose F, 10
    Form1.SetupChambers
End Sub

Private Sub LoadGuide(Sleft As String)
Dim F As Integer
Dim I As Integer
Dim File As String
Dim T As String
Dim Path As String

    Path = GetIniString(INIFILE, "PATH", "GUIDE")
    If Len(Path) = 0 Then Path = App.Path
    File = Path & "\" & TTrim(Sleft) & ".ggx"
    ShowInfo "Chargement des infos guide " & GetFname(File)
    F = IsOpen(File, "R", 10)
    If F = 0 Then
        ShowFatal "--- " & GetFname(File) & " introuvable ---"
        Exit Sub
    End If
    For I = 0 To 3
        Line Input #F, T
        Form1.TxG(I) = T
    Next
    XClose F, 10
    Form1.SetupGuides
End Sub

Private Function MarkRunning(ToAdd As String)

    If InStr(RunList, UCase(ToAdd)) <> 0 Then   ' Already running
        MarkRunning = False
        Exit Function
    Else
        RunList = RunList & UCase(ToAdd) & ","  'Add in list
        MarkRunning = True
    End If
    
End Function

Private Sub FreeRunning(ToRemove As String)
Dim I As Integer

    I = InStr(RunList, UCase(ToRemove))
    If I > 0 Then RunList = Left(RunList, Len(RunList) - Len(ToRemove))
End Sub
